'-----------------------------------------------------------------------------
'
'                        zasilacz z PCF 8591 i komunikacj RS 232
'                                 kosc AT89C2051 podejscie 2
'
'
' - z rs232
' - dodatkowy przetwornik c/a 4bit do ograniczania pradu
' - szybkie odaczenie napicia
' - zakres U 0...30V ; I 0...1,0A
'-----------------------------------------------------------------------------
$baud = 2400
$noramclear
$crystal = 11059200
Config Sda = P1.0
Config Scl = P3.7
Config Lcd = 20 * 2
Tmod = 33
Dim Nic As Byte
Dim Pom1 As Byte
Dim Pom2 As Byte
Dim Pom As Byte
Dim Liczba As Byte
Dim Temp1 As Byte
Dim Pomcur As Byte
Dim Curent As Byte
Dim Voltage As Byte
Dim Nap As Byte
Dim Prad As Byte
Dim Temp2 As Byte
Dim U As Single
Dim I As Single
On Timer0 Wysw                                 'Nosave                          ' Uwaga !!!
On Int0 Reg                                    'Nosave                             'Nie Sprawdzone
Ie = 131
Declare Sub Ustaw
Declare Sub Odczyt
Declare Sub Analiza
Declare Sub Wyswietl
Declare Sub Ustawpr
Liczba = 0
Curent = 15
Voltage = 0

   Cls
   Cursor Off

   Lcd "Zasilacz stab"

Call Ustaw
Call Ustawpr
Start Timer0

 Do


   Pom = Inkey()
    If Pom > 0 Then

      Incr Liczba
     If Pom = 13 Then

     Liczba = 0
       clr ie.7
        Call Analiza
       setb ie.7
     End If


     If Liczba = 1 Then

      Pom1 = Pom

     Else

      Pom2 = Pom
     End If

   End If
 Loop
End

Sub Ustaw
  I2cstart
  I2cwbyte &B10010000
  I2cwbyte &B01000100
  I2cwbyte Voltage
  I2cstop
End Sub

Sub Odczyt
 I2cstart
 I2cwbyte &B10010001
 I2crbyte Nic , Ack
 I2crbyte Nap , Ack
 I2crbyte Prad , Ack
 I2crbyte Nic , Nack
 I2cstop
End Sub

Wysw:

 mov tl0,#&hba
 mov th0,#&hdb

  Incr Temp1
  Incr Temp2

   If Temp1 = 10 Then
     Call Odczyt
   End If

   If Temp1 = 20 Then
    Call Wyswietl
     Temp1 = 0
  End If

  If Temp2 = 250 Then
   Call Ustaw
   Temp2 = 0
  End If
Return

Reg:
     clr ie.7
      If P3.4 = 0 Then
        If P3.3 = 0 Then
          If Curent > 0 Then
           Decr Curent

          End If
        Else
          If Curent < 15 Then
           Incr Curent
          End If
        End If
        Call Ustawpr
      Else
        If P3.3 = 0 Then
          If Voltage > 0 Then
           Decr Voltage
          End If
        Else
          If Voltage < 255 Then
           Incr Voltage
          End If
        End If

          Call Ustaw

      End If

         Waitms 100
       Call Odczyt
       Call Wyswietl
      setb ie.7
Return

Sub Analiza

 If Pom2 = 63 Then

  If Pom1 = 117 Then

   Print "U" ; U
  End If

  If Pom1 = 105 Then

   Print "I" ; I

  End If

 End If

End Sub

Sub Wyswietl

  If Prad = 255 Then
       Reset P3.5
      Else
       Set P3.5
      End If

     U = Nap / 8.5
     I = Prad / 255                            'korekta pomiaru pradu

    Lowerline

   Lcd U
   Locate 2 , 6
   Lcd "V   "
   Lcd I
   Locate 2 , 15
   Lcd "A   "

End Sub

Sub Ustawpr
  Set P1.1
      Waitms 5
      Reset P1.1
       Waitms 3

      For Pomcur = 1 To Curent

      Set P1.1
       nop
       nop

      Reset P1.1

      Next Pomcur

End Sub